diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/phased-array-model.h ns-3.34/src/antenna/model/phased-array-model.h
--- ns-3.33/src/antenna/model/phased-array-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/phased-array-model.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,145 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef PHASED_ARRAY_MODEL_H
+#define PHASED_ARRAY_MODEL_H
+
+#include <ns3/object.h>
+#include <ns3/angles.h>
+#include <complex>
+#include <ns3/antenna-model.h>
+
+namespace ns3 {
+
+
+/**
+ * \ingroup antenna
+ *
+ * \brief Class implementing the phased array model virtual base class.
+ */
+class PhasedArrayModel : public Object
+{
+public:
+  /**
+   * Constructor
+   */
+  PhasedArrayModel (void);
+
+
+  /**
+   * Destructor
+   */
+  virtual ~PhasedArrayModel (void);
+
+
+  // inherited from Object
+  static TypeId GetTypeId (void);
+
+
+  typedef std::vector<std::complex<double> > ComplexVector; //!< type definition for complex vectors
+
+  /**
+   * Returns the horizontal and vertical components of the antenna element field
+   * pattern at the specified direction. Only vertical polarization is considered.
+   * \param a the angle indicating the interested direction
+   * \return a pair in which the first element is the horizontal component
+   *         of the field pattern and the second element is the vertical
+   *         component of the field pattern
+   */
+  virtual std::pair<double, double> GetElementFieldPattern (Angles a) const = 0;
+
+
+  /**
+   * Returns the location of the antenna element with the specified
+   * index, normalized with respect to the wavelength.
+   * \param idx index of the antenna element
+   * \return the 3D vector that represents the position of the element
+   */
+  virtual Vector GetElementLocation (uint64_t index) const = 0;
+
+
+  /**
+   * Returns the number of antenna elements
+   * \return the number of antenna elements
+   */
+  virtual uint64_t GetNumberOfElements (void) const = 0;
+
+
+  /**
+   * Sets the beamforming vector to be used
+   * \param beamformingVector the beamforming vector
+   */
+  void SetBeamformingVector (const ComplexVector &beamformingVector);
+
+
+  /**
+   * Returns the beamforming vector that is currently being used
+   * \return the current beamforming vector
+   */
+  ComplexVector GetBeamformingVector (void) const;
+
+
+  /**
+   * Returns the beamforming vector that points towards the specified position
+   * \param a the beamforming angle
+   * \return the beamforming vector
+   */
+  ComplexVector GetBeamformingVector (Angles a) const;
+
+
+  /**
+   * Returns the steering vector that points toward the specified position
+   * \param a the steering angle
+   * \return the steering vector
+   */
+  ComplexVector GetSteeringVector (Angles a) const;
+
+
+  /**
+   * Sets the antenna model to be used
+   * \param antennaElement the antenna model
+   */
+  void SetAntennaElement (Ptr<AntennaModel> antennaElement);
+
+
+  /**
+   * Returns a pointer to the AntennaModel instance used to model the elements of the array
+   * \return pointer to the AntennaModel instance
+   */
+  Ptr<const AntennaModel> GetAntennaElement (void) const;
+
+protected:
+  /**
+   * Utility method to compute the euclidean norm of a ComplexVector
+   * \param vector the ComplexVector
+   * \return the euclidean norm
+   */
+  static double ComputeNorm (const ComplexVector &vector);
+
+  ComplexVector m_beamformingVector; //!< the beamforming vector in use
+  Ptr<AntennaModel> m_antennaElement; //!< the model of the antenna element in use
+  bool m_isBfVectorValid; //!< ensures the validity of the beamforming vector
+
+};
+
+
+std::ostream& operator<< (std::ostream& os, const PhasedArrayModel::ComplexVector& cv);
+
+} /* namespace ns3 */
+
+#endif /* PHASED_ARRAY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/three-gpp-antenna-model.cc ns-3.34/src/antenna/model/three-gpp-antenna-model.cc
--- ns-3.33/src/antenna/model/three-gpp-antenna-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/three-gpp-antenna-model.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,118 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+
+#include <ns3/log.h>
+#include <ns3/double.h>
+#include <cmath>
+#include "antenna-model.h"
+#include "three-gpp-antenna-model.h"
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("ThreeGppAntennaModel");
+
+NS_OBJECT_ENSURE_REGISTERED (ThreeGppAntennaModel);
+
+
+TypeId
+ThreeGppAntennaModel::GetTypeId ()
+{
+  static TypeId tid = TypeId ("ns3::ThreeGppAntennaModel")
+    .SetParent<AntennaModel> ()
+    .SetGroupName ("Antenna")
+    .AddConstructor<ThreeGppAntennaModel> ()
+  ;
+  return tid;
+}
+
+ThreeGppAntennaModel::ThreeGppAntennaModel (void)
+  : m_verticalBeamwidthDegrees {65},
+    m_horizontalBeamwidthDegrees {65},
+    m_aMax {30},
+    m_slaV {30},
+    m_geMax {8.0}
+{}
+
+
+ThreeGppAntennaModel::~ThreeGppAntennaModel (void)
+{}
+
+
+double
+ThreeGppAntennaModel::GetVerticalBeamwidth () const
+{
+  return m_verticalBeamwidthDegrees;
+}
+
+
+double
+ThreeGppAntennaModel::GetHorizontalBeamwidth () const
+{
+  return m_horizontalBeamwidthDegrees;
+}
+
+
+double
+ThreeGppAntennaModel::GetSlaV () const
+{
+  return m_slaV;
+}
+
+
+double
+ThreeGppAntennaModel::GetMaxAttenuation () const
+{
+  return m_aMax;
+}
+
+
+double
+ThreeGppAntennaModel::GetAntennaElementGain () const
+{
+  return m_geMax;
+}
+
+
+double
+ThreeGppAntennaModel::GetGainDb (Angles a)
+{
+  NS_LOG_FUNCTION (this << a);
+
+  double phiDeg = RadiansToDegrees (a.GetAzimuth ());
+  double thetaDeg = RadiansToDegrees (a.GetInclination ());
+
+  NS_ASSERT_MSG (-180.0 <= phiDeg && phiDeg <= 180.0, "Out of boundaries: phiDeg=" << phiDeg);
+  NS_ASSERT_MSG (0.0 <= thetaDeg && thetaDeg <= 180.0, "Out of boundaries: thetaDeg=" << thetaDeg);
+
+  // compute the radiation power pattern using equations in table 7.3-1 in
+  // 3GPP TR 38.901
+  double vertGain = -std::min (m_slaV, 12 * pow ((thetaDeg - 90) / m_verticalBeamwidthDegrees, 2)); // vertical cut of the radiation power pattern (dB)
+  double horizGain = -std::min (m_aMax, 12 * pow (phiDeg / m_horizontalBeamwidthDegrees, 2)); // horizontal cut of the radiation power pattern (dB)
+
+  double gainDb = m_geMax - std::min (m_aMax, -(vertGain + horizGain));  // 3D radiation power pattern (dB)
+
+  NS_LOG_DEBUG ("gain=" << gainDb << " dB");
+  return gainDb;
+
+}
+
+
+}
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/three-gpp-antenna-model.h ns-3.34/src/antenna/model/three-gpp-antenna-model.h
--- ns-3.33/src/antenna/model/three-gpp-antenna-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/three-gpp-antenna-model.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,90 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef THREE_GPP_ANTENNA_MODEL_H
+#define THREE_GPP_ANTENNA_MODEL_H
+
+
+#include <ns3/object.h>
+#include <ns3/antenna-model.h>
+
+namespace ns3 {
+
+/**
+ *
+ * \brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
+ *
+ * This class implements the parabolic model as described in 3GPP TR 38.901 v15.0.0
+ *
+ */
+class ThreeGppAntennaModel : public AntennaModel
+{
+public:
+  ThreeGppAntennaModel (void);
+  virtual ~ThreeGppAntennaModel (void) override;
+
+  // inherited from Object
+  static TypeId GetTypeId ();
+
+  // inherited from AntennaModel
+  virtual double GetGainDb (Angles a) override;
+
+  /**
+   * Get the vertical beamwidth of the antenna element.
+   * \return the vertical beamwidth in degrees
+   */
+  double GetVerticalBeamwidth () const;
+
+  /**
+   * Get the horizontal beamwidth of the antenna element.
+   * \return the horizontal beamwidth in degrees
+   */
+  double GetHorizontalBeamwidth () const;
+
+  /**
+   * Get the side-lobe attenuation in the vertical direction of the antenna element.
+   * \return side-lobe attenuation in the vertical direction in dB
+   */
+  double GetSlaV () const;
+
+  /**
+   * Get the naximum attenuation of the antenna element.
+   * \return the naximum attenuation in dB
+   */
+  double GetMaxAttenuation () const;
+
+  /**
+   * Get the maximum directional gain of the antenna element.
+   * \return the maximum directional gain in dBi
+   */
+  double GetAntennaElementGain () const;
+
+private:
+  double m_verticalBeamwidthDegrees;    //!< beamwidth in the vertical direction (\theta_{3dB}) [deg]
+  double m_horizontalBeamwidthDegrees;  //!< beamwidth in the horizontal direction (\phi_{3dB}) [deg]
+  double m_aMax;                        //!< maximum attenuation (A_{max}) [dB]
+  double m_slaV;                        //!< side-lobe attenuation in the vertical direction (SLA_V) [dB]
+  double m_geMax;                       //!< maximum directional gain of the antenna element (G_{E,max}) [dBi]
+};
+
+
+
+} // namespace ns3
+
+
+#endif // THREE_GPP_ANTENNA_MODEL_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/uniform-planar-array.cc ns-3.34/src/antenna/model/uniform-planar-array.cc
--- ns-3.33/src/antenna/model/uniform-planar-array.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/uniform-planar-array.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,233 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+
+#include "uniform-planar-array.h"
+#include <ns3/log.h>
+#include <ns3/double.h>
+#include <ns3/uinteger.h>
+#include <ns3/boolean.h>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("UniformPlanarArray");
+
+NS_OBJECT_ENSURE_REGISTERED (UniformPlanarArray);
+
+
+
+UniformPlanarArray::UniformPlanarArray ()
+  : PhasedArrayModel (),
+    m_numColumns {1},
+    m_numRows {1},
+    m_disV {0.5},
+    m_disH {0.5},
+    m_alpha {0},
+    m_beta {0}
+{}
+
+UniformPlanarArray::~UniformPlanarArray ()
+{}
+
+TypeId
+UniformPlanarArray::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::UniformPlanarArray")
+    .SetParent<PhasedArrayModel> ()
+    .AddConstructor<UniformPlanarArray> ()
+    .SetGroupName ("Antenna")
+    .AddAttribute ("AntennaHorizontalSpacing",
+                   "Horizontal spacing between antenna elements, in multiples of wave length",
+                   DoubleValue (0.5),
+                   MakeDoubleAccessor (&UniformPlanarArray::SetAntennaHorizontalSpacing,
+                                       &UniformPlanarArray::GetAntennaHorizontalSpacing),
+                   MakeDoubleChecker<double> (0.0))
+    .AddAttribute ("AntennaVerticalSpacing",
+                   "Vertical spacing between antenna elements, in multiples of wave length",
+                   DoubleValue (0.5),
+                   MakeDoubleAccessor (&UniformPlanarArray::SetAntennaVerticalSpacing,
+                                       &UniformPlanarArray::GetAntennaVerticalSpacing),
+                   MakeDoubleChecker<double> (0.0))
+    .AddAttribute ("NumColumns",
+                   "Horizontal size of the array",
+                   UintegerValue (4),
+                   MakeUintegerAccessor (&UniformPlanarArray::SetNumColumns,
+                                         &UniformPlanarArray::GetNumColumns),
+                   MakeUintegerChecker<uint32_t> (1))
+    .AddAttribute ("NumRows",
+                   "Vertical size of the array",
+                   UintegerValue (4),
+                   MakeUintegerAccessor (&UniformPlanarArray::SetNumRows,
+                                         &UniformPlanarArray::GetNumRows),
+                   MakeUintegerChecker<uint32_t> (1))
+    .AddAttribute ("BearingAngle",
+                   "The bearing angle in radians",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&UniformPlanarArray::m_alpha),
+                   MakeDoubleChecker<double> (-M_PI, M_PI))
+    .AddAttribute ("DowntiltAngle",
+                   "The downtilt angle in radians",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&UniformPlanarArray::m_beta),
+                   MakeDoubleChecker<double> (-M_PI, M_PI))
+  ;
+  return tid;
+}
+
+
+void
+UniformPlanarArray::SetNumColumns (uint32_t n)
+{
+  NS_LOG_FUNCTION (this << n);
+  if (n != m_numColumns)
+    {
+      m_isBfVectorValid = false;
+    }
+  m_numColumns = n;
+}
+
+
+uint32_t
+UniformPlanarArray::GetNumColumns (void) const
+{
+  return m_numColumns;
+}
+
+
+void
+UniformPlanarArray::SetNumRows (uint32_t n)
+{
+  NS_LOG_FUNCTION (this << n);
+  if (n != m_numRows)
+    {
+      m_isBfVectorValid = false;
+    }
+  m_numRows = n;
+}
+
+
+uint32_t
+UniformPlanarArray::GetNumRows (void) const
+{
+  return m_numRows;
+}
+
+
+void
+UniformPlanarArray::SetAntennaHorizontalSpacing (double s)
+{
+  NS_LOG_FUNCTION (this << s);
+  NS_ABORT_MSG_IF (s <= 0, "Trying to set an invalid spacing: " << s);
+
+  if (s != m_disH)
+    {
+      m_isBfVectorValid = false;
+    }
+  m_disH = s;
+}
+
+
+double
+UniformPlanarArray::GetAntennaHorizontalSpacing (void) const
+{
+  return m_disH;
+}
+
+
+void
+UniformPlanarArray::SetAntennaVerticalSpacing (double s)
+{
+  NS_LOG_FUNCTION (this << s);
+  NS_ABORT_MSG_IF (s <= 0, "Trying to set an invalid spacing: " << s);
+
+  if (s != m_disV)
+    {
+      m_isBfVectorValid = false;
+    }
+  m_disV = s;
+}
+
+
+double
+UniformPlanarArray::GetAntennaVerticalSpacing (void) const
+{
+  return m_disV;
+}
+
+
+std::pair<double, double>
+UniformPlanarArray::GetElementFieldPattern (Angles a) const
+{
+  NS_LOG_FUNCTION (this << a);
+
+  // convert the theta and phi angles from GCS to LCS using eq. 7.1-7 and 7.1-8 in 3GPP TR 38.901
+  // NOTE we assume a fixed slant angle of 0 degrees
+  double thetaPrime = std::acos (cos (m_beta) * cos (a.GetInclination ()) + sin (m_beta) * cos (a.GetAzimuth () - m_alpha) * sin (a.GetInclination ()));
+  double phiPrime = std::arg (std::complex<double> (cos (m_beta) * sin (a.GetInclination ()) * cos (a.GetAzimuth () - m_alpha) - sin (m_beta) * cos (a.GetInclination ()), sin (a.GetAzimuth () - m_alpha) * sin (a.GetInclination ())));
+  Angles aPrime (phiPrime, thetaPrime);
+  NS_LOG_DEBUG (a << " -> " << aPrime);
+
+  // compute the antenna element field pattern in the vertical polarization using
+  // eq. 7.3-4 in 3GPP TR 38.901
+  // NOTE we assume vertical polarization, hence the field pattern in the
+  // horizontal polarization is 0
+  double aPrimeDb = m_antennaElement->GetGainDb (aPrime);
+  double fieldThetaPrime = pow (10, aPrimeDb / 20); // convert to linear magnitude
+
+  // compute psi using eq. 7.1-15 in 3GPP TR 38.901, assuming that the slant
+  // angle (gamma) is 0
+  double psi = std::arg (std::complex<double> (cos (m_beta) * sin (a.GetInclination ()) - sin (m_beta) * cos (a.GetInclination ()) * cos (a.GetAzimuth () - m_alpha), sin (m_beta) * sin (a.GetAzimuth () - m_alpha)));
+  NS_LOG_DEBUG ("psi " << psi);
+
+  // convert the antenna element field pattern to GCS using eq. 7.1-11
+  // in 3GPP TR 38.901
+  double fieldTheta = cos (psi) * fieldThetaPrime;
+  double fieldPhi = sin (psi) * fieldThetaPrime;
+  NS_LOG_DEBUG (RadiansToDegrees (a.GetAzimuth ()) << " " << RadiansToDegrees (a.GetInclination ()) << " " << fieldTheta * fieldTheta + fieldPhi * fieldPhi);
+
+  return std::make_pair (fieldPhi, fieldTheta);
+}
+
+
+Vector
+UniformPlanarArray::GetElementLocation (uint64_t index) const
+{
+  NS_LOG_FUNCTION (this << index);
+
+  // compute the element coordinates in the LCS
+  // assume the left bottom corner is (0,0,0), and the rectangular antenna array is on the y-z plane.
+  double xPrime = 0;
+  double yPrime = m_disH * (index % m_numColumns);
+  double zPrime = m_disV * floor (index / m_numColumns);
+
+  // convert the coordinates to the GCS using the rotation matrix 7.1-4 in 3GPP
+  // TR 38.901
+  Vector loc;
+  loc.x = cos (m_alpha) * cos (m_beta) * xPrime - sin (m_alpha) * yPrime + cos (m_alpha) * sin (m_beta) * zPrime;
+  loc.y = sin (m_alpha) * cos (m_beta) * xPrime + cos (m_alpha) * yPrime + sin (m_alpha) * sin (m_beta) * zPrime;
+  loc.z = -sin (m_beta) * xPrime + cos (m_beta) * zPrime;
+  return loc;
+}
+
+uint64_t
+UniformPlanarArray::GetNumberOfElements () const
+{
+  return m_numRows * m_numColumns;
+}
+
+} /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/antenna/model/uniform-planar-array.h ns-3.34/src/antenna/model/uniform-planar-array.h
--- ns-3.33/src/antenna/model/uniform-planar-array.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/antenna/model/uniform-planar-array.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,166 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+*   Copyright (c) 2020 University of Padova, Dep. of Information Engineering, SIGNET lab.
+*
+*   This program is free software; you can redistribute it and/or modify
+*   it under the terms of the GNU General Public License version 2 as
+*   published by the Free Software Foundation;
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef UNIFORM_PLANAR_ARRAY_H
+#define UNIFORM_PLANAR_ARRAY_H
+
+
+#include <ns3/object.h>
+#include <ns3/phased-array-model.h>
+
+
+namespace ns3 {
+
+
+/**
+ * \ingroup antenna
+ *
+ * \brief Class implementing Uniform Planar Array (UPA) model.
+ *
+ * \note the current implementation supports the modeling of antenna arrays
+ * composed of a single panel and with single (vertical) polarization.
+ */
+class UniformPlanarArray : public PhasedArrayModel
+{
+public:
+  /**
+   * Constructor
+   */
+  UniformPlanarArray (void);
+
+
+  /**
+   * Destructor
+   */
+  virtual ~UniformPlanarArray (void);
+
+
+  // inherited from Object
+  static TypeId GetTypeId (void);
+
+
+  /**
+   * Returns the horizontal and vertical components of the antenna element field
+   * pattern at the specified direction. Only vertical polarization is considered.
+   * \param a the angle indicating the interested direction
+   * \return a pair in which the first element is the horizontal component
+   *         of the field pattern and the second element is the vertical
+   *         component of the field pattern
+   */
+  std::pair<double, double> GetElementFieldPattern (Angles a) const override;
+
+
+  /**
+  * Returns the location of the antenna element with the specified
+  * index assuming the left bottom corner is (0,0,0), normalized
+  * with respect to the wavelength.
+  * Antenna elements are scanned row by row, left to right and bottom to top.
+  * For example, an antenna with 2 rows and 3 columns will be ordered as follows:
+  * ^ z
+  * |  3 4 5
+  * |  0 1 2
+  * ----------> y
+  *
+  * \param index index of the antenna element
+  * \return the 3D vector that represents the position of the element
+  */
+  Vector GetElementLocation (uint64_t index) const override;
+
+  /**
+   * Returns the number of antenna elements
+   * \return the number of antenna elements
+   */
+  uint64_t GetNumberOfElements (void) const override;
+
+private:
+  /**
+   * Set the number of columns of the phased array
+   * This method resets the stored beamforming vector to a ComplexVector
+   * of the correct size, but zero-filled
+   * \param n the number of columns
+   */
+  void SetNumColumns (uint32_t n);
+
+
+  /**
+   * Get the number of columns of the phased array
+   * \return the number of columns
+   */
+  uint32_t GetNumColumns (void) const;
+
+
+  /**
+   * Set the number of rows of the phased array
+   * This method resets the stored beamforming vector to a ComplexVector
+   * of the correct size, but zero-filled
+   * \param n the number of rows
+   */
+  void SetNumRows (uint32_t n);
+
+
+  /**
+   * Get the number of rows of the phased array
+   * \return the number of rows
+   */
+  uint32_t GetNumRows (void) const;
+
+
+  /**
+   * Set the horizontal spacing for the antenna elements of the phased array
+   * This method resets the stored beamforming vector to a ComplexVector
+   * of the correct size, but zero-filled
+   * \param s the horizontal spacing in multiples of wavelength
+   */
+  void SetAntennaHorizontalSpacing (double s);
+
+
+  /**
+   * Get the horizontal spacing for the antenna elements of the phased array
+   * \return the horizontal spacing in multiples of wavelength
+   */
+  double GetAntennaHorizontalSpacing (void) const;
+
+
+  /**
+   * Set the vertical spacing for the antenna elements of the phased array
+   * This method resets the stored beamforming vector to a ComplexVector
+   * of the correct size, but zero-filled
+   * \param s the vertical spacing in multiples of wavelength
+   */
+  void SetAntennaVerticalSpacing (double s);
+
+
+  /**
+   * Get the vertical spacing for the antenna elements of the phased array
+   * \return the vertical spacing in multiples of wavelength
+   */
+  double GetAntennaVerticalSpacing (void) const;
+
+
+  uint32_t m_numColumns; //!< number of columns
+  uint32_t m_numRows; //!< number of rows
+  double m_disV; //!< antenna spacing in the vertical direction in multiples of wave length
+  double m_disH; //!< antenna spacing in the horizontal direction in multiples of wave length
+  double m_alpha; //!< the bearing angle in radians
+  double m_beta; //!< the downtilt angle in radians
+
+};
+
+} /* namespace ns3 */
+
+#endif /* UNIFORM_PLANAR_ARRAY_H */
